import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import * as path from "path";
import express from "express";
import cookieParser from "cookie-parser";
import { fs, createDebugger, compatRequire } from "@modern-js/utils";
import finalhandler from "finalhandler";
import { run } from "./context";
import registerRoutes from "./registerRoutes";
var debug = createDebugger("express");
var findAppModule = function() {
  var _ref = _async_to_generator(function(apiDir) {
    var exts, paths, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, filename, err;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          exts = [
            ".ts",
            ".js"
          ];
          paths = exts.map(function(ext) {
            return path.resolve(apiDir, "app".concat(ext));
          });
          _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = void 0;
          _state.label = 1;
        case 1:
          _state.trys.push([
            1,
            6,
            7,
            8
          ]);
          _iterator = paths[Symbol.iterator]();
          _state.label = 2;
        case 2:
          if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done))
            return [
              3,
              5
            ];
          filename = _step.value;
          return [
            4,
            fs.pathExists(filename)
          ];
        case 3:
          if (_state.sent()) {
            delete require.cache[filename];
            return [
              2,
              [
                compatRequire(filename),
                require(filename)
              ]
            ];
          }
          _state.label = 4;
        case 4:
          _iteratorNormalCompletion = true;
          return [
            3,
            2
          ];
        case 5:
          return [
            3,
            8
          ];
        case 6:
          err = _state.sent();
          _didIteratorError = true;
          _iteratorError = err;
          return [
            3,
            8
          ];
        case 7:
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
          return [
            7
          ];
        case 8:
          return [
            2,
            []
          ];
      }
    });
  });
  return function findAppModule2(apiDir) {
    return _ref.apply(this, arguments);
  };
}();
var initMiddlewares = function(middleware, app) {
  middleware.forEach(function(middlewareItem) {
    var middlewareFunc = typeof middlewareItem === "string" ? compatRequire(middlewareItem) : middlewareItem;
    app.use(middlewareFunc);
  });
};
var useRun = function(app) {
  app.use(function(req, res, next) {
    run({
      req,
      res
    }, next);
  });
};
var initApp = function(app) {
  app.use(cookieParser());
  app.use(express.text());
  app.use(express.urlencoded({
    extended: true
  }));
  app.use(express.json());
  return app;
};
function plugin_default() {
  return {
    name: "@modern-js/plugin-express",
    pre: [
      "@modern-js/plugin-bff"
    ],
    post: [
      "@modern-js/plugin-server"
    ],
    setup: function(api) {
      return {
        prepareApiServer: function prepareApiServer(param) {
          var pwd = param.pwd, config = param.config, render = param.render;
          return _async_to_generator(function() {
            var _userConfig_bff, app, appContext, apiHandlerInfos, apiDirectory, apiDir, mode, userConfig, appModule, hooks, middleware, afterLambdaRegisted, middleware1;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  appContext = api.useAppContext();
                  apiHandlerInfos = appContext.apiHandlerInfos;
                  apiDirectory = appContext.apiDirectory;
                  apiDir = apiDirectory || path.join(pwd, "./api");
                  mode = appContext.apiMode;
                  userConfig = api.useConfigContext();
                  if (!(mode === "framework"))
                    return [
                      3,
                      2
                    ];
                  return [
                    4,
                    findAppModule(apiDir)
                  ];
                case 1:
                  appModule = _state.sent();
                  app = appModule[0];
                  hooks = appModule[1];
                  if (!(app === null || app === void 0 ? void 0 : app.use)) {
                    app = express();
                  }
                  initApp(app);
                  if (config) {
                    middleware = config.middleware;
                    initMiddlewares(middleware, app);
                  }
                  useRun(app);
                  registerRoutes(app, apiHandlerInfos);
                  if (hooks) {
                    afterLambdaRegisted = hooks.afterLambdaRegisted;
                    if (afterLambdaRegisted) {
                      afterLambdaRegisted(app);
                    }
                  }
                  return [
                    3,
                    3
                  ];
                case 2:
                  if (mode === "function") {
                    app = express();
                    initApp(app);
                    if (config) {
                      middleware1 = config.middleware;
                      initMiddlewares(middleware1, app);
                    }
                    useRun(app);
                    registerRoutes(app, apiHandlerInfos);
                  } else {
                    throw new Error("mode must be function or framework");
                  }
                  _state.label = 3;
                case 3:
                  if (((_userConfig_bff = userConfig.bff) === null || _userConfig_bff === void 0 ? void 0 : _userConfig_bff.enableHandleWeb) && render) {
                    app.use(function() {
                      var _ref = _async_to_generator(function(req, res, next) {
                        var html;
                        return _ts_generator(this, function(_state2) {
                          switch (_state2.label) {
                            case 0:
                              return [
                                4,
                                render(req, res)
                              ];
                            case 1:
                              html = _state2.sent();
                              if (html) {
                                res.end(html);
                              }
                              next();
                              return [
                                2
                              ];
                          }
                        });
                      });
                      return function(req, res, next) {
                        return _ref.apply(this, arguments);
                      };
                    }());
                  }
                  return [
                    2,
                    function(req, res) {
                      return new Promise(function(resolve, reject) {
                        var handler = function(err) {
                          if (err) {
                            return reject(err);
                          }
                          return finalhandler(req, res, {})(null);
                        };
                        res.on("finish", function(err) {
                          if (err) {
                            return reject(err);
                          }
                          return resolve();
                        });
                        return app(req, res, handler);
                      });
                    }
                  ];
              }
            });
          })();
        },
        prepareWebServer: function prepareWebServer(param, next) {
          var config = param.config;
          var _userConfig_server;
          var userConfig = api.useConfigContext();
          if (!(userConfig === null || userConfig === void 0 ? void 0 : (_userConfig_server = userConfig.server) === null || _userConfig_server === void 0 ? void 0 : _userConfig_server.enableFrameworkExt)) {
            return next();
          }
          var app = express();
          initApp(app);
          if (config) {
            var middleware = config.middleware;
            debug("web middleware", middleware);
            initMiddlewares(middleware, app);
          }
          return function(ctx) {
            return new Promise(function(resolve, reject) {
              var _ctx_source = ctx.source, req = _ctx_source.req, res = _ctx_source.res;
              var handler = function(err) {
                if (err) {
                  return reject(err);
                }
                if (res.headersSent && res.statusCode !== 200) {
                  finalhandler(req, res, {})(null);
                }
                return resolve();
              };
              res.on("finish", function(err) {
                if (err) {
                  return reject(err);
                }
                return resolve();
              });
              return app(req, res, handler);
            });
          };
        }
      };
    }
  };
}
;
export {
  plugin_default as default
};
