import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _instanceof } from "@swc/helpers/_/_instanceof";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _sliced_to_array } from "@swc/helpers/_/_sliced_to_array";
import { _ as _to_consumable_array } from "@swc/helpers/_/_to_consumable_array";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import "reflect-metadata";
import { httpMethods, isWithMetaHandler, isInputParamsDeciderHandler, HttpMetadata, ResponseMetaType, ValidationError } from "@modern-js/bff-core";
import { isSchemaHandler } from "@modern-js/bff-runtime";
import typeIs from "type-is";
import formidable from "formidable";
var handleResponseMeta = function(res, handler) {
  var responseMeta = Reflect.getMetadata(HttpMetadata.Response, handler);
  if (Array.isArray(responseMeta)) {
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = void 0;
    try {
      for (var _iterator = responseMeta[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var meta = _step.value;
        var metaType = meta.type;
        var metaValue = meta.value;
        switch (metaType) {
          case ResponseMetaType.Headers:
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = void 0;
            try {
              for (var _iterator1 = Object.entries(metaValue)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true) {
                var _step_value = _sliced_to_array(_step1.value, 2), key = _step_value[0], value = _step_value[1];
                res.append(key, value);
              }
            } catch (err) {
              _didIteratorError1 = true;
              _iteratorError1 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                  _iterator1.return();
                }
              } finally {
                if (_didIteratorError1) {
                  throw _iteratorError1;
                }
              }
            }
            break;
          case ResponseMetaType.Redirect:
            res.redirect(metaValue);
            break;
          case ResponseMetaType.StatusCode:
            res.status(metaValue);
            break;
          default:
            break;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }
};
var createRouteHandler = function(handler) {
  var apiHandler = function() {
    var _ref = _async_to_generator(function(req, res, next) {
      var input, result, error, result1, _input_data, args, body, e, args1, body1, e1;
      return _ts_generator(this, function(_state) {
        switch (_state.label) {
          case 0:
            return [
              4,
              getInputFromRequest(req)
            ];
          case 1:
            input = _state.sent();
            if (!isWithMetaHandler(handler))
              return [
                3,
                6
              ];
            _state.label = 2;
          case 2:
            _state.trys.push([
              2,
              4,
              ,
              5
            ]);
            handleResponseMeta(res, handler);
            if (res.headersSent) {
              return [
                2
              ];
            }
            return [
              4,
              handler(input)
            ];
          case 3:
            result = _state.sent();
            if (result && typeof result === "object") {
              return [
                2,
                res.json(result)
              ];
            }
            return [
              3,
              5
            ];
          case 4:
            error = _state.sent();
            if (_instanceof(error, ValidationError)) {
              res.status(error.status);
              return [
                2,
                res.json({
                  message: error.message
                })
              ];
            }
            throw error;
          case 5:
            return [
              3,
              19
            ];
          case 6:
            if (!isSchemaHandler(handler))
              return [
                3,
                8
              ];
            return [
              4,
              handler(input)
            ];
          case 7:
            result1 = _state.sent();
            if (result1.type !== "HandleSuccess") {
              if (result1.type === "InputValidationError") {
                res.status(400);
              } else {
                res.status(500);
              }
              return [
                2,
                res.json(result1.message)
              ];
            } else {
              res.status(200);
              return [
                2,
                res.json(result1.value)
              ];
            }
            return [
              3,
              19
            ];
          case 8:
            if (!isInputParamsDeciderHandler(handler))
              return [
                3,
                13
              ];
            _state.label = 9;
          case 9:
            _state.trys.push([
              9,
              11,
              ,
              12
            ]);
            args = (input === null || input === void 0 ? void 0 : (_input_data = input.data) === null || _input_data === void 0 ? void 0 : _input_data.args) || [];
            return [
              4,
              handler.apply(void 0, _to_consumable_array(args))
            ];
          case 10:
            body = _state.sent();
            if (typeof body !== "undefined") {
              if (typeof body === "object") {
                return [
                  2,
                  res.json(body)
                ];
              }
              return [
                2,
                res.send(body)
              ];
            }
            return [
              3,
              12
            ];
          case 11:
            e = _state.sent();
            return [
              2,
              next(e)
            ];
          case 12:
            return [
              3,
              19
            ];
          case 13:
            args1 = Object.values(input.params).concat(input);
            _state.label = 14;
          case 14:
            _state.trys.push([
              14,
              18,
              ,
              19
            ]);
            return [
              4,
              handler.apply(void 0, _to_consumable_array(args1))
            ];
          case 15:
            body1 = _state.sent();
            if (!res.headersSent)
              return [
                3,
                17
              ];
            return [
              4,
              Promise.resolve()
            ];
          case 16:
            return [
              2,
              _state.sent()
            ];
          case 17:
            if (typeof body1 !== "undefined") {
              return [
                2,
                res.json(body1)
              ];
            }
            return [
              3,
              19
            ];
          case 18:
            e1 = _state.sent();
            return [
              2,
              next(e1)
            ];
          case 19:
            return [
              2
            ];
        }
      });
    });
    return function apiHandler2(req, res, next) {
      return _ref.apply(this, arguments);
    };
  }();
  Object.defineProperties(apiHandler, Object.getOwnPropertyDescriptors(handler));
  return apiHandler;
};
var isNormalMethod = function(httpMethod) {
  return httpMethods.includes(httpMethod);
};
var getInputFromRequest = function() {
  var _ref = _async_to_generator(function(request) {
    var draft;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          draft = {
            params: request.params,
            query: request.query,
            headers: request.headers,
            cookies: request.headers.cookie
          };
          if (!typeIs(request, [
            "application/json"
          ]))
            return [
              3,
              1
            ];
          draft.data = request.body;
          return [
            3,
            4
          ];
        case 1:
          if (!typeIs(request, [
            "multipart/form-data"
          ]))
            return [
              3,
              3
            ];
          return [
            4,
            resolveFormData(request)
          ];
        case 2:
          draft.formData = _state.sent();
          return [
            3,
            4
          ];
        case 3:
          if (typeIs(request, [
            "application/x-www-form-urlencoded"
          ])) {
            draft.formUrlencoded = request.body;
          } else {
            draft.body = request.body;
          }
          _state.label = 4;
        case 4:
          return [
            2,
            draft
          ];
      }
    });
  });
  return function getInputFromRequest2(request) {
    return _ref.apply(this, arguments);
  };
}();
var resolveFormData = function(request) {
  var form = formidable({
    multiples: true
  });
  return new Promise(function(resolve, reject) {
    form.parse(request, function(err, fields, files) {
      if (err) {
        reject(err);
      }
      resolve(_object_spread({}, fields, files));
    });
  });
};
export {
  createRouteHandler,
  isNormalMethod
};
